#if ANDROID || IOS || DESKTOP_GL
#define REQUIRES_PRIMARY_THREAD_LOADING
#endif
// The project is not new enough to support GlueView 2. It is on version 0
//#define SUPPORTS_GLUEVIEW_2
using Color = Microsoft.Xna.Framework.Color;
using System.Linq;
using FlatRedBall.Graphics;
using FlatRedBall.Math;
using FlatRedBall;
using System;
using System.Collections.Generic;
using System.Text;
using FlatRedBall.Math.Geometry;
namespace Beefball.Entities
{
    public partial class PlayerBall : FlatRedBall.PositionedObject, FlatRedBall.Graphics.IDestroyable, FlatRedBall.Math.Geometry.ICollidable
    {
        // This is made static so that static lazy-loaded content can access it.
        public static string ContentManagerName { get; set; }
        #if DEBUG
        static bool HasBeenLoadedWithGlobalContentManager = false;
        #endif
        public class VariableState
        {
            public string Name;
            public float X;
            public float Y;
            public float Z;
            public float MovementSpeed;
            public float Drag;
            public float DashSpeed;
            public float DashFrequency;
            public float CooldownCircleRadius;
            public Microsoft.Xna.Framework.Color BodyColor;
            public Microsoft.Xna.Framework.Color CooldownCircleColor;
            public static VariableState Tired = new VariableState()
            {
                Name = "Tired",
                MovementSpeed = 100f,
                Drag = 1f,
                DashSpeed = 600f,
                DashFrequency = 2f,
                CooldownCircleRadius = 0f,
                BodyColor = Color.White,
                CooldownCircleColor = Color.White,
            }
            ;
            public static VariableState Rested = new VariableState()
            {
                Name = "Rested",
                MovementSpeed = 100f,
                Drag = 1f,
                DashSpeed = 600f,
                DashFrequency = 2f,
                CooldownCircleRadius = 16f,
                BodyColor = Color.White,
                CooldownCircleColor = Color.White,
            }
            ;
            public static Dictionary<string, VariableState> AllStates = new Dictionary<string, VariableState>
            {
                {"Tired", Tired},
                {"Rested", Rested},
            }
            ;
        }
        private VariableState mCurrentState = null;
        public Entities.PlayerBall.VariableState CurrentState
        {
            get
            {
                return mCurrentState;
            }
            set
            {
                mCurrentState = value;
                if (value != null)
                {
                    if (this.Parent == null)
                    {
                        X = value.X;
                    }
                    else
                    {
                        RelativeX = value.X;
                    }
                    if (this.Parent == null)
                    {
                        Y = value.Y;
                    }
                    else
                    {
                        RelativeY = value.Y;
                    }
                    if (this.Parent == null)
                    {
                        Z = value.Z;
                    }
                    else
                    {
                        RelativeZ = value.Z;
                    }
                    MovementSpeed = value.MovementSpeed;
                    Drag = value.Drag;
                    DashSpeed = value.DashSpeed;
                    DashFrequency = value.DashFrequency;
                    CooldownCircleRadius = value.CooldownCircleRadius;
                    BodyColor = value.BodyColor;
                    CooldownCircleColor = value.CooldownCircleColor;
                }
            }
        }
        static object mLockObject = new object();
        static System.Collections.Generic.List<string> mRegisteredUnloads = new System.Collections.Generic.List<string>();
        static System.Collections.Generic.List<string> LoadedContentManagers = new System.Collections.Generic.List<string>();
        
        private FlatRedBall.Math.Geometry.Circle mBody;
        public FlatRedBall.Math.Geometry.Circle Body
        {
            get
            {
                return mBody;
            }
            private set
            {
                mBody = value;
            }
        }
        private FlatRedBall.Math.Geometry.Circle mCooldownCircle;
        public FlatRedBall.Math.Geometry.Circle CooldownCircle
        {
            get
            {
                return mCooldownCircle;
            }
            private set
            {
                mCooldownCircle = value;
            }
        }
        public float MovementSpeed = 100f;
        public float DashSpeed = 600f;
        public float DashFrequency = 2f;
        public float CooldownCircleRadius
        {
            get
            {
                return CooldownCircle.Radius;
            }
            set
            {
                CooldownCircle.Radius = value;
            }
        }
        #if XNA3 || SILVERLIGHT
        public Microsoft.Xna.Framework.Graphics.Color BodyColor
        #else
        public Microsoft.Xna.Framework.Color BodyColor
        #endif
        {
            get
            {
                return Body.Color;
            }
            set
            {
                Body.Color = value;
            }
        }
        #if XNA3 || SILVERLIGHT
        public Microsoft.Xna.Framework.Graphics.Color CooldownCircleColor
        #else
        public Microsoft.Xna.Framework.Color CooldownCircleColor
        #endif
        {
            get
            {
                return CooldownCircle.Color;
            }
            set
            {
                CooldownCircle.Color = value;
            }
        }
        private FlatRedBall.Math.Geometry.ShapeCollection mGeneratedCollision;
        public FlatRedBall.Math.Geometry.ShapeCollection Collision
        {
            get
            {
                return mGeneratedCollision;
            }
        }
        protected FlatRedBall.Graphics.Layer LayerProvidedByContainer = null;
        public PlayerBall () 
        	: this(FlatRedBall.Screens.ScreenManager.CurrentScreen.ContentManagerName, true)
        {
        }
        public PlayerBall (string contentManagerName) 
        	: this(contentManagerName, true)
        {
        }
        public PlayerBall (string contentManagerName, bool addToManagers) 
        	: base()
        {
            ContentManagerName = contentManagerName;
            InitializeEntity(addToManagers);
        }
        protected virtual void InitializeEntity (bool addToManagers) 
        {
            LoadStaticContent(ContentManagerName);
            mBody = new FlatRedBall.Math.Geometry.Circle();
            mBody.Name = "Body";
            mCooldownCircle = new FlatRedBall.Math.Geometry.Circle();
            mCooldownCircle.Name = "CooldownCircle";
            
            PostInitialize();
            if (addToManagers)
            {
                AddToManagers(null);
            }
        }
        public virtual void ReAddToManagers (FlatRedBall.Graphics.Layer layerToAddTo) 
        {
            LayerProvidedByContainer = layerToAddTo;
            FlatRedBall.SpriteManager.AddPositionedObject(this);
            FlatRedBall.Math.Geometry.ShapeManager.AddToLayer(mBody, LayerProvidedByContainer);
            FlatRedBall.Math.Geometry.ShapeManager.AddToLayer(mCooldownCircle, LayerProvidedByContainer);
        }
        public virtual void AddToManagers (FlatRedBall.Graphics.Layer layerToAddTo) 
        {
            LayerProvidedByContainer = layerToAddTo;
            FlatRedBall.SpriteManager.AddPositionedObject(this);
            FlatRedBall.Math.Geometry.ShapeManager.AddToLayer(mBody, LayerProvidedByContainer);
            FlatRedBall.Math.Geometry.ShapeManager.AddToLayer(mCooldownCircle, LayerProvidedByContainer);
            AddToManagersBottomUp(layerToAddTo);
            CustomInitialize();
        }
        public virtual void Activity () 
        {
            
            CustomActivity();
        }
        public virtual void Destroy () 
        {
            FlatRedBall.SpriteManager.RemovePositionedObject(this);
            
            if (Body != null)
            {
                FlatRedBall.Math.Geometry.ShapeManager.Remove(Body);
            }
            if (CooldownCircle != null)
            {
                FlatRedBall.Math.Geometry.ShapeManager.Remove(CooldownCircle);
            }
            mGeneratedCollision.RemoveFromManagers(clearThis: true);
            CustomDestroy();
        }
        public virtual void PostInitialize () 
        {
            bool oldShapeManagerSuppressAdd = FlatRedBall.Math.Geometry.ShapeManager.SuppressAddingOnVisibilityTrue;
            FlatRedBall.Math.Geometry.ShapeManager.SuppressAddingOnVisibilityTrue = true;
            if (mBody.Parent == null)
            {
                mBody.CopyAbsoluteToRelative();
                mBody.AttachTo(this, false);
            }
            Body.Radius = 16f;
            if (mCooldownCircle.Parent == null)
            {
                mCooldownCircle.CopyAbsoluteToRelative();
                mCooldownCircle.AttachTo(this, false);
            }
            CooldownCircle.Radius = 16f;
            mGeneratedCollision = new FlatRedBall.Math.Geometry.ShapeCollection();
            Collision.Circles.AddOneWay(mBody);
            Collision.Circles.AddOneWay(mCooldownCircle);
            FlatRedBall.Math.Geometry.ShapeManager.SuppressAddingOnVisibilityTrue = oldShapeManagerSuppressAdd;
        }
        public virtual void AddToManagersBottomUp (FlatRedBall.Graphics.Layer layerToAddTo) 
        {
            AssignCustomVariables(false);
        }
        public virtual void RemoveFromManagers () 
        {
            FlatRedBall.SpriteManager.ConvertToManuallyUpdated(this);
            if (Body != null)
            {
                FlatRedBall.Math.Geometry.ShapeManager.RemoveOneWay(Body);
            }
            if (CooldownCircle != null)
            {
                FlatRedBall.Math.Geometry.ShapeManager.RemoveOneWay(CooldownCircle);
            }
            mGeneratedCollision.RemoveFromManagers(clearThis: false);
        }
        public virtual void AssignCustomVariables (bool callOnContainedElements) 
        {
            if (callOnContainedElements)
            {
            }
            Body.Radius = 16f;
            CooldownCircle.Radius = 16f;
            MovementSpeed = 100f;
            Drag = 1f;
            DashSpeed = 600f;
            DashFrequency = 2f;
            CooldownCircleRadius = 16f;
            BodyColor = Color.White;
            CooldownCircleColor = Color.White;
        }
        public virtual void ConvertToManuallyUpdated () 
        {
            this.ForceUpdateDependenciesDeep();
            FlatRedBall.SpriteManager.ConvertToManuallyUpdated(this);
        }
        public static void LoadStaticContent (string contentManagerName) 
        {
            if (string.IsNullOrEmpty(contentManagerName))
            {
                throw new System.ArgumentException("contentManagerName cannot be empty or null");
            }
            ContentManagerName = contentManagerName;
            #if DEBUG
            if (contentManagerName == FlatRedBall.FlatRedBallServices.GlobalContentManager)
            {
                HasBeenLoadedWithGlobalContentManager = true;
            }
            else if (HasBeenLoadedWithGlobalContentManager)
            {
                throw new System.Exception("This type has been loaded with a Global content manager, then loaded with a non-global.  This can lead to a lot of bugs");
            }
            #endif
            bool registerUnload = false;
            if (LoadedContentManagers.Contains(contentManagerName) == false)
            {
                LoadedContentManagers.Add(contentManagerName);
                lock (mLockObject)
                {
                    if (!mRegisteredUnloads.Contains(ContentManagerName) && ContentManagerName != FlatRedBall.FlatRedBallServices.GlobalContentManager)
                    {
                        FlatRedBall.FlatRedBallServices.GetContentManagerByName(ContentManagerName).AddUnloadMethod("PlayerBallStaticUnload", UnloadStaticContent);
                        mRegisteredUnloads.Add(ContentManagerName);
                    }
                }
            }
            if (registerUnload && ContentManagerName != FlatRedBall.FlatRedBallServices.GlobalContentManager)
            {
                lock (mLockObject)
                {
                    if (!mRegisteredUnloads.Contains(ContentManagerName) && ContentManagerName != FlatRedBall.FlatRedBallServices.GlobalContentManager)
                    {
                        FlatRedBall.FlatRedBallServices.GetContentManagerByName(ContentManagerName).AddUnloadMethod("PlayerBallStaticUnload", UnloadStaticContent);
                        mRegisteredUnloads.Add(ContentManagerName);
                    }
                }
            }
            CustomLoadStaticContent(contentManagerName);
        }
        public static void UnloadStaticContent () 
        {
            if (LoadedContentManagers.Count != 0)
            {
                LoadedContentManagers.RemoveAt(0);
                mRegisteredUnloads.RemoveAt(0);
            }
            if (LoadedContentManagers.Count == 0)
            {
            }
        }
        static VariableState mLoadingState = null;
        public static VariableState LoadingState
        {
            get
            {
                return mLoadingState;
            }
            set
            {
                mLoadingState = value;
            }
        }
        public FlatRedBall.Instructions.Instruction InterpolateToState (VariableState stateToInterpolateTo, double secondsToTake) 
        {
            if (stateToInterpolateTo == VariableState.Tired)
            {
                CooldownCircle.RadiusVelocity = (0f - CooldownCircle.Radius) / (float)secondsToTake;
            }
            else if (stateToInterpolateTo == VariableState.Rested)
            {
                CooldownCircle.RadiusVelocity = (16f - CooldownCircle.Radius) / (float)secondsToTake;
            }
            var instruction = new FlatRedBall.Instructions.DelegateInstruction<VariableState>(StopStateInterpolation, stateToInterpolateTo);
            instruction.TimeToExecute = FlatRedBall.TimeManager.CurrentTime + secondsToTake;
            this.Instructions.Add(instruction);
            return instruction;
        }
        public void StopStateInterpolation (VariableState stateToStop) 
        {
            if (stateToStop == VariableState.Tired)
            {
                CooldownCircle.RadiusVelocity =  0;
            }
            else if (stateToStop == VariableState.Rested)
            {
                CooldownCircle.RadiusVelocity =  0;
            }
            CurrentState = stateToStop;
        }
        public void InterpolateBetween (VariableState firstState, VariableState secondState, float interpolationValue) 
        {
            #if DEBUG
            if (float.IsNaN(interpolationValue))
            {
                throw new System.Exception("interpolationValue cannot be NaN");
            }
            #endif
            bool setCooldownCircleRadius = true;
            float CooldownCircleRadiusFirstValue= 0;
            float CooldownCircleRadiusSecondValue= 0;
            if (firstState == VariableState.Tired)
            {
                CooldownCircleRadiusFirstValue = 0f;
            }
            else if (firstState == VariableState.Rested)
            {
                CooldownCircleRadiusFirstValue = 16f;
            }
            if (secondState == VariableState.Tired)
            {
                CooldownCircleRadiusSecondValue = 0f;
            }
            else if (secondState == VariableState.Rested)
            {
                CooldownCircleRadiusSecondValue = 16f;
            }
            if (setCooldownCircleRadius)
            {
                CooldownCircleRadius = CooldownCircleRadiusFirstValue * (1 - interpolationValue) + CooldownCircleRadiusSecondValue * interpolationValue;
            }
            if (interpolationValue < 1)
            {
                mCurrentState = firstState;
            }
            else
            {
                mCurrentState = secondState;
            }
        }
        public static void PreloadStateContent (VariableState state, string contentManagerName) 
        {
            ContentManagerName = contentManagerName;
            if (state == VariableState.Tired)
            {
            }
            else if (state == VariableState.Rested)
            {
            }
        }
        [System.Obsolete("Use GetFile instead")]
        public static object GetStaticMember (string memberName) 
        {
            return null;
        }
        public static object GetFile (string memberName) 
        {
            return null;
        }
        object GetMember (string memberName) 
        {
            return null;
        }
        public static void Reload (object whatToReload) 
        {
        }
        protected bool mIsPaused;
        public override void Pause (FlatRedBall.Instructions.InstructionList instructions) 
        {
            base.Pause(instructions);
            mIsPaused = true;
        }
        public virtual void SetToIgnorePausing () 
        {
            FlatRedBall.Instructions.InstructionManager.IgnorePausingFor(this);
            FlatRedBall.Instructions.InstructionManager.IgnorePausingFor(Body);
            FlatRedBall.Instructions.InstructionManager.IgnorePausingFor(CooldownCircle);
        }
        public virtual void MoveToLayer (FlatRedBall.Graphics.Layer layerToMoveTo) 
        {
            var layerToRemoveFrom = LayerProvidedByContainer;
            if (layerToRemoveFrom != null)
            {
                layerToRemoveFrom.Remove(Body);
            }
            FlatRedBall.Math.Geometry.ShapeManager.AddToLayer(Body, layerToMoveTo);
            if (layerToRemoveFrom != null)
            {
                layerToRemoveFrom.Remove(CooldownCircle);
            }
            FlatRedBall.Math.Geometry.ShapeManager.AddToLayer(CooldownCircle, layerToMoveTo);
            LayerProvidedByContainer = layerToMoveTo;
        }
        partial void CustomActivityEditMode();
    }
}
